'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _WatchmanWatchFileSystem = require('./WatchmanWatchFileSystem');

var _WatchmanWatchFileSystem2 = _interopRequireDefault(_WatchmanWatchFileSystem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var debug = (0, _debug2.default)('watchman:plugin');

var WatchmanPlugin = function () {
  function WatchmanPlugin() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { projectPath: '' };

    _classCallCheck(this, WatchmanPlugin);

    if (!options.projectPath) throw new Error('projectPath is missing for WatchmanPlugin');

    this.options = options;
  }

  _createClass(WatchmanPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      compiler.plugin('environment', function () {
        debug('creating new filesystem');
        compiler.watchFileSystem = new _WatchmanWatchFileSystem2.default( // eslint-disable-line no-param-reassign
        compiler.inputFileSystem, _this.options);
      });
    }
  }]);

  return WatchmanPlugin;
}();

exports.default = WatchmanPlugin;